#include <Xm/PushB.h>
#include <Xm/CascadeB.h>
#include <Xm/Text.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/TextF.h>
#include <Xm/Label.h>

#define OK      1
#define CANCEL  2
XmStringCharSet charset=XmSTRING_DEFAULT_CHARSET;

Widget menu_item(item_basename,client_info,menu,call)
   char *item_basename;
   int client_info;
   Widget menu;
   XtCallbackProc call;
/* adds an item into a menu */
{
   int ac;
   Arg a1[10];
   Widget item;
   ac=0;
   item=XmCreatePushButton(menu,item_basename,NULL,0);
   XtAddCallback(item,XmNactivateCallback,call,(XtPointer)client_info); 
   XtManageChild(item);
   XtSetSensitive(item,True);
   return(item);
}

Widget design_menu(menu_type,menubar)
   char *menu_type;
   Widget menubar;
{
   int ac;
   Arg a1[10];
   Widget menyou,cascade_b;
   ac=0;
   menyou=(Widget ) XmCreatePulldownMenu(menubar, menu_type,NULL,0);
   ac=0;
   XtSetArg(a1[ac],XmNsubMenuId,menyou);ac++;
   cascade_b=XmCreateCascadeButton(menubar, menu_type,a1,ac);
   XtManageChild(cascade_b);
   return(menyou);
}

Widget new_form(char *item_name, Widget w)
{
   Widget form_x;
   form_x=XmCreateForm(w,item_name,NULL,0);
   XtManageChild(form_x);
   return(form_x);
}

Widget new_menubar(char *item_name,Widget w)
{
   Widget menubar_x;
   menubar_x= (Widget) XmCreateMenuBar(w,item_name,NULL,0);
   XtManageChild(menubar_x);
   return(menubar_x);
}

Widget new_text(char *item_name, Widget w)
{
   Widget text_x;
   text_x = (Widget) XmCreateScrolledText(w,item_name,NULL,0);
   XtManageChild(text_x);
   return(text_x);
}

Widget new_field(char *item_name, Widget w)
{
   Widget text_x;
   text_x = (Widget) XmCreateTextField(w,item_name,NULL,0);
   XtManageChild(text_x);
   return(text_x);
}
Widget file_dial(char *item_name, Widget w)
{
    Widget dialog_x;
    dialog_x = (Widget) XmCreateFileSelectionDialog(w,item_name,NULL,0);
    XtUnmanageChild(XmSelectionBoxGetChild(dialog_x,XmDIALOG_HELP_BUTTON));
    XtSetSensitive(dialog_x,True);
    return(dialog_x);
}

Widget prompt_dial(char *item_name,char *message, Widget w,XtCallbackProc call)
{
   Widget dial_x;
   Arg a1[10];
   int ac;
   ac=0;
  XtSetArg(a1[ac],XmNselectionLabelString,
               XmStringCreateLtoR(message,charset));ac++;
  dial_x=(Widget )XmCreatePromptDialog(w,item_name,a1,ac);
  XtSetSensitive(dial_x,True);
  XtAddCallback(dial_x,XmNokCallback,call,OK);
  XtAddCallback(dial_x,XmNcancelCallback,call,CANCEL);
  XtUnmanageChild(XmSelectionBoxGetChild(dial_x,XmDIALOG_HELP_BUTTON));
  return(dial_x);
}

Widget message_box(char *item_name,char *message,Widget w)
{
   Widget dial_x;
   Arg a1[10];
   int ac;
   ac=0;
  XtSetArg(a1[ac],XmNmessageString,
               XmStringCreateLtoR(message,charset));ac++;
  dial_x=(Widget )XmCreateWarningDialog(w,item_name,a1,ac);
  XtSetSensitive(dial_x,True);
  XtUnmanageChild(XmMessageBoxGetChild(dial_x,XmDIALOG_HELP_BUTTON));
  return(dial_x);
}

Widget new_label(char *item_name,Widget w)
{
   Widget label_x;
   Arg a1[10];
   int ac;
   ac=0;
   XtSetArg(a1[ac],XmNlabelString, XmStringCreate(item_name,charset));ac++;
   label_x=XmCreateLabel(w,item_name,a1,ac);
   XtManageChild(label_x);
   return(label_x);
}

Widget new_button(char *item_name,Widget w)
{
   Widget button_x;
   button_x=XmCreatePushButton(w,item_name,NULL,0);
   XtManageChild(button_x);
   XtSetSensitive(button_x,True);
   return(button_x);
}

Widget new_list(char *item_name,Widget w)
{
   Widget list_x;
   list_x=XmCreateList(w,item_name,NULL,0); 
   XtManageChild(list_x);
   return(list_x);
}

Widget add2list(char *item, Widget w)
{
   XmListAddItem(w, (XmString) item, 0);
}           

Widget rem_list(char *item, Widget w)
{
   XmListDeleteItem(w, (XmString) item);
}

Widget clean_list(Widget w)
{
   XmListDeleteAllItems(w);
}
